(function() {
  var Baker, exec, fs, path, resolve, span, spawn, uniq, _ref;
  var __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (__hasProp.call(this, i) && this[i] === item) return i; } return -1; };

  fs = require('fs');

  path = require('path');

  _ref = require('child_process'), exec = _ref.exec, spawn = _ref.spawn;

  uniq = function(array) {
    var element, list, _i, _len;
    list = [];
    for (_i = 0, _len = array.length; _i < _len; _i++) {
      element = array[_i];
      if (__indexOf.call(list, element) < 0) list.push(element);
    }
    return list;
  };

  span = function(file, extname, callback) {
    var name;
    if (extname != null) {
      name = "-name '*" + extname + "'";
    } else {
      name = '';
    }
    file = "./" + (path.relative('./', file));
    return exec("find " + file + " -type f " + name + " -regex '\.\/[^\.].+[^~]$'", function(error, stdout) {
      if (error) throw error;
      return typeof callback === "function" ? callback(stdout.slice(0, -1).split('\n')) : void 0;
    });
  };

  resolve = function(paths, extname, callback) {
    var bad, badSpanned, cbCount, file, finalStep, good, goodSpanned, _i, _j, _len, _len2;
    var _this = this;
    good = [];
    bad = [];
    goodSpanned = [];
    badSpanned = [];
    cbCount = paths.length;
    good = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = paths.length; _i < _len; _i++) {
        file = paths[_i];
        if (file[0] !== '!') _results.push(file);
      }
      return _results;
    })();
    bad = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = paths.length; _i < _len; _i++) {
        file = paths[_i];
        if (file[0] === '!') _results.push(file);
      }
      return _results;
    })();
    for (_i = 0, _len = good.length; _i < _len; _i++) {
      file = good[_i];
      span(file, extname, function(spanned) {
        goodSpanned = goodSpanned.concat(spanned);
        cbCount -= 1;
        if (cbCount === 0) return finalStep();
      });
    }
    for (_j = 0, _len2 = bad.length; _j < _len2; _j++) {
      file = bad[_j];
      span(file.slice(1), extname, function(spanned) {
        badSpanned = spanned;
        cbCount -= 1;
        if (cbCount === 0) return finalStep();
      });
    }
    return finalStep = function() {
      var element;
      goodSpanned = uniq(goodSpanned);
      badSpanned = uniq(badSpanned);
      return typeof callback === "function" ? callback((function() {
        var _k, _len3, _results;
        _results = [];
        for (_k = 0, _len3 = goodSpanned.length; _k < _len3; _k++) {
          element = goodSpanned[_k];
          if (__indexOf.call(badSpanned, element) < 0) _results.push(element);
        }
        return _results;
      })()) : void 0;
    };
  };

  Baker = (function() {

    function Baker(options) {
      this.options = options;
    }

    Baker.prototype.open = function(editor, openList) {
      this.editor = editor;
      this.openList = openList;
    };

    Baker.prototype.openLS = function(callback) {
      return resolve(this.openList, '', callback);
    };

    Baker.prototype.openFiles = function() {
      var _this = this;
      return resolve(this.openList, '', function(list) {
        return exec("" + _this.editor + " " + (list.join(' ')), function(error, stdout) {
          if (error) throw error;
        });
      });
    };

    Baker.prototype.buildNumber = 0;

    Baker.prototype.buildData = [];

    Baker.prototype.buildLS = function(callback) {
      var build, buildData, counter, source, _i, _len, _ref2, _results;
      var _this = this;
      buildData = [];
      counter = this.buildData.length;
      _ref2 = this.buildData;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        build = _ref2[_i];
        if (!(build.source instanceof Array)) {
          source = [build.source];
        } else {
          source = build.source;
        }
        _results.push(resolve(source, build.extname, function(data) {
          counter -= 1;
          buildData.push({
            extname: build.extname,
            source: data,
            command: build.command('#{ source }')
          });
          if (counter === 0) return callback(buildData);
        }));
      }
      return _results;
    };

    Baker.prototype.build = function(extname, source, command) {
      this.buildData.push({
        extname: extname,
        source: source,
        command: command
      });
      return this.buildNumber += 1;
    };

    Baker.prototype.buildAll = function(callback) {
      var build, buildData, counter, source, _i, _len, _ref2, _results;
      var _this = this;
      buildData = [];
      counter = this.buildData.length;
      _ref2 = this.buildData;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        build = _ref2[_i];
        if (!(build.source instanceof Array)) {
          source = [build.source];
        } else {
          source = build.source;
        }
        _results.push(resolve(source, build.extname, function(data) {
          spawn(build.command(data));
          counter -= 1;
          if (counter === 0) {
            return typeof callback === "function" ? callback() : void 0;
          }
        }));
      }
      return _results;
    };

    return Baker;

  })();

  module.exports = new Baker;

}).call(this);
