fs              = require 'fs'
path            = require 'path'
{exec, spawn}   = require 'child_process'

# produce a duplicate-free list
uniq = (array) ->
    list = []
    for element in array
        if element not in list then list.push element
    return list

# resolve a path into the containing files
span = (file, extname, callback) ->
    if extname?
        name = "-name '*#{ extname }'"
    else
        name = ''
    file = "./#{ path.relative './', file }"
    exec "find #{ file } -type f #{ name } -regex '\.\/[^\.].+[^~]$'", (error, stdout) ->
        if error then throw error
        callback? stdout[..-2].split '\n'
    
resolve = (paths, extname, callback) ->
    
    good = []
    bad = []
    goodSpanned = []
    badSpanned = []
    cbCount = paths.length
    
    good = (file for file in paths when file[0] isnt '!')
    bad = (file for file in paths when file[0] is '!')
    
    for file in good
        span file, extname, (spanned) ->
            goodSpanned = goodSpanned.concat spanned
            cbCount -= 1
            if cbCount is 0 then finalStep()
            
    for file in bad
        span file[1..], extname, (spanned) ->
            badSpanned = spanned
            cbCount -= 1
            if cbCount is 0 then finalStep()
            
    finalStep = =>
        goodSpanned = uniq goodSpanned        
        badSpanned = uniq badSpanned        
        # filter the bad ones out from the good ones
        callback? (element for element in goodSpanned when element not in badSpanned)
        
    
class Baker
    

    constructor: (@options) ->
    
    open: (@editor, @openList) ->
    
    openLS: (callback) -> 
        resolve @openList, '', callback
    openFiles: ->
        resolve @openList, '', (list) =>
            exec "#{ @editor } #{ list.join ' ' }", (error, stdout) ->
                if error then throw error      
               
    buildNumber: 0
    buildData: []
    
    buildLS: (callback) ->
    
        buildData = []
        counter = @buildData.length
        
        for build in @buildData    
            # wrap it up
            unless build.source instanceof Array
                source = [build.source]
            else
                source = build.source
            
            resolve source, build.extname, (data) =>
                        
                # decr counter
                counter -= 1
            
                buildData.push (
                    extname: build.extname
                    source: data
                    command: build.command '#{ source }'
                )
            
                if counter is 0 then callback buildData
        
    build: (extname, source, command) ->
    
        @buildData.push (
            extname: extname
            source: source
            command: command
        )
        
        # incr buildNumber
        @buildNumber += 1
        
    buildAll: (callback) ->
    
        buildData = []
        counter = @buildData.length
        
        for build in @buildData    
        
        
            # wrap it up
            unless build.source instanceof Array
                source = [build.source]
            else
                source = build.source
            
            resolve source, build.extname, (data) =>
            
                spawn build.command data
                
                counter -= 1
                
                if counter is 0 then callback?()
                
                
module.exports = new Baker
